<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Platzi Sat 1</title>
</head>

<link rel="stylesheet" href="css/index.css">
<link rel="stylesheet" href="libs/leaflet/leaflet.css"
      integrity="sha256-p4NxAoJBhIIN+hmNHrzRCf9tD/miZyoHS5obTRR9BMY="
      crossorigin=""/>
<script src="libs/leaflet/leaflet.js"
        integrity="sha256-20nQCchB9co0qIjJZRGuk2/Z9VM+kNiyxNV1lvTlZBo="
        crossorigin=""></script>

<script src="libs/satellite/satellite.min.js"></script>

<body>
    <div id="map"></div>

    <script>
        let tleRaw = [
            "FOSSASAT FEROX",
            "1 88888U 24001FA  23163.94096086  .00000000  00000-0  10000-4 0  9999",
            "2 88888  97.5077 280.5424 0008220 228.6198 130.8530 15.11803180  1009"
        ];

        let observer = {
            latitude: 19.508781239571896,
            longitude: -99.1538205837351,
            elevation: 2240
        }

        let map
        let satelliteMarker
        let satellitePreviousPosition = null

        initMap();
        updateData();
        drawOrbit();

        setInterval(updateData,1000);

        function drawOrbit(){
            let timestamp = new Date();

            console.log(`Timestamp: ${timestamp}`)

            for(let i=0; i<3382; i++){
                timestamp.setMilliseconds(timestamp.getMilliseconds() + i)
                let satelliteLocation = getSatelliteUpdatedLocation(tleRaw, timestamp)
                if(satellitePreviousPosition!=null) {
                    const diff = satelliteLocation.longitude - satellitePreviousPosition.longitude

                    if(diff<300) {
                        drawLine(satellitePreviousPosition, satelliteLocation)
                    }
                }
                satellitePreviousPosition = satelliteLocation;
            }
        }

        function updateData() {
            let satelliteLocation = getSatelliteUpdatedLocation(tleRaw)
            console.log(`Satellite: ${JSON.stringify(satelliteLocation)}`);

            let observerPoint = getGroundStationOrientation(tleRaw, observer)
            console.log(`Observer: ${JSON.stringify(observerPoint)}`);

            satelliteMarker.setLatLng([satelliteLocation.latitude, satelliteLocation.longitude])
        }

        function getSatelliteUpdatedLocation(tleRaw, timestamp = new Date()) {
            const satrec = satellite.twoline2satrec(tleRaw[1], tleRaw[2]);
            const positionAndVelocity = satellite.propagate(satrec, timestamp);
            const positionEci = positionAndVelocity.position;

            const gmst = satellite.gstime(timestamp);
            const positionGd = satellite.eciToGeodetic(positionEci, gmst);

            const location = {
                latitude: satellite.degreesLat(positionGd.latitude),
                longitude: satellite.degreesLong(positionGd.longitude),
            };

            return location;
        }

        function getGroundStationOrientation(tleRaw, observer) {
            const satrec = satellite.twoline2satrec(tleRaw[1], tleRaw[2]);
            const positionAndVelocity = satellite.propagate(satrec, new Date());
            const positionEci = positionAndVelocity.position;

            const gmst = satellite.gstime(new Date());
            const positionEcf = satellite.eciToEcf(positionEci, gmst);

            const observerGd = {
                latitude: satellite.degreesToRadians(observer.latitude),
                longitude: satellite.degreesToRadians(observer.longitude),
                height: observer.elevation,
            };

            const lookAngles = satellite.ecfToLookAngles(observerGd, positionEcf);

            const orientation = {
                azimuth: lookAngles.azimuth,
                elevation: lookAngles.elevation,
                rangeSat: lookAngles.rangeSat,
            };

            return orientation;
        }

        function initMap(){
            map = L.map('map').setView([0, 0], 1);
            satelliteMarker = L.marker([0, 0]).addTo(map);
            L.tileLayer('https://tile.openstreetmap.org/{z}/{x}/{y}.png', {
                maxZoom: 10,
                attribution: '© OpenStreetMap'
            }).addTo(map);

        }

        function drawLine(A,B){
            let pointA = new L.LatLng(A.latitude, A.longitude);
            let pointB = new L.LatLng(B.latitude, B.longitude);
            let pointList = [pointA, pointB];

            const firstpolyline = new L.Polyline(pointList, {color: 'red', weight: 3, opacity: 0.5, smoothFactor: 1});

            map.addLayer(firstpolyline);
        }
    </script>
</body>

</html>
